/*

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

package instance

import (
	"fmt"

	interfaces "k8s.libre.sh/interfaces"

	"github.com/presslabs/controller-util/syncer"
)

//type ObjectMeta interface {
//	GetLabels() map[string]string
//	SetLabels(labels map[string]string)
//	GetName() string
//	SetName(string)
//	GetNamespace() string
//	SetNamespace(string)
//}

type Object interface {
	// GetObjectKind() string
	Meta
	Mutate(obj interfaces.Object) error
	GetObject() interfaces.Object
	//	SetSettings(settings settings.Parameters)
	//	GenObject() interfaces.Object
}

func SetObjectMeta(instance Meta, dest Meta) {

	dest.SetLabels(InstanceLabels(instance))

	if len(dest.GetName()) == 0 {
		dest.SetName(fmt.Sprintf("%v-%v", instance.GetInstance(), dest.GetComponent()))
		fmt.Println(fmt.Sprintf("%v-%v", instance.GetInstance(), dest.GetComponent()))
	}
	if len(dest.GetNamespace()) == 0 {
		dest.SetNamespace(instance.GetNamespace())

	}
}

func NewObjectSyncer(i Object, owner interfaces.Object, r interfaces.Reconcile) syncer.Interface {
	obj := i.GetObject()
	obj.SetName(i.GetName())
	obj.SetNamespace(i.GetNamespace())

	//	fmt.Println("YOHOUHHHHHOUH")
	//	fmt.Println(obj.GetName())
	return syncer.NewObjectSyncer(obj.GetObjectKind().GroupVersionKind().Kind, owner, obj, r.GetClient(), r.GetScheme(), func() error {
		// i.Mutate(obj)
		return i.Mutate(obj)
	})
}
