/*

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

package meta

import (
	interfaces "k8s.libre.sh/interfaces"
)

type Meta interface {
	GetLabels() map[string]string
	SetLabels(labels map[string]string)
	GetName() string
	SetName(string)
	GetNamespace() string
	SetNamespace(string)
}

func MutateMeta(o Meta, obj interfaces.Object) error {
	obj.SetLabels(o.GetLabels())
	if len(obj.GetName()) == 0 {
		obj.SetName(o.GetName())

	}

	if len(obj.GetNamespace()) == 0 {
		obj.SetNamespace(o.GetNamespace())
	}

	return nil
}
