package service

import (
	meta "k8s.libre.sh/meta"
	corev1 "k8s.io/api/core/v1"
)

type Mutate interface {
	GetServicePorts() []corev1.ServicePort
	//	GetServiceProtocol() corev1.Protocol
	GetServiceType() corev1.ServiceType
}

func MutateService(r Mutate, obj *corev1.Service, m meta.Meta) error {

	obj.Spec.Type = r.GetServiceType()
	obj.Spec.Ports = r.GetServicePorts()

	obj.Spec.Selector = m.GetLabels()

	return nil
}
